
/*
 * This is IVTC 4 ports ODM project to use Moxa CPU.
 *
 * History:
 *	Date		Author				Comment
 *	12-12-2005	Victor Yu.			Create it.
 */
#include        <stdio.h>
#include        <stdlib.h>
#include        <fcntl.h>
#include        "ivtcdevice.h"

#define KEYPAD_DEVICE_NODE	"/dev/keypad"

// following about KEYPAD
// ioctl command define
// ioctl(fd, IOCTL_KEYPAD_HAS_PRESS, &no)
// ioctl(fd, IOCTL_KEYPAD_GET_KEY, &value)
#define IOCTL_KEYPAD_HAS_PRESS  1       // to check any key has pressed, 0 - means no, > 0 has pressed key number
#define IOCTL_KEYPAD_GET_KEY    2       // to get has pressed key value

int	keypad_pressed_no(void)
{
	int	fd, ret;

	fd = open(KEYPAD_DEVICE_NODE, O_RDONLY);
	if ( fd <=0 )
		return fd;
	ioctl(fd, IOCTL_KEYPAD_HAS_PRESS, &ret);
	close(fd);
	return ret;
}

unsigned int	keypad_get(void)
{
	int		fd;
	unsigned int	ret;

	fd = open(KEYPAD_DEVICE_NODE, O_RDONLY);
	if ( fd <=0 )
		return fd;
	ioctl(fd, IOCTL_KEYPAD_GET_KEY, &ret);
	close(fd);
	return ret;
}
