
/*
 * This is IVTC 4 ports ODM project to use Moxa CPU.
 *
 * History:
 *	Date		Author				Comment
 *	12-12-2005	Victor Yu.			Create it.
 */
#include        <stdio.h>
#include        <stdlib.h>
#include        <fcntl.h>
#include        "ivtcdevice.h"

#define LCM_DEVICE_NODE	"/dev/lcm"
// ioctl(fd, IOCTL_LCM_GOTO_XY, &pos)
// ioctl(fd, IOCTL_LCM_CLS, NULL)
// ioctl(fd, IOCTL_LCM_CLEAN_LINE, NULL)
// ioctl(fd, IOCTL_LCM_GET_XY, &pos)
// ioctl(fd, IOCTL_LCM_BACK_LIGHT_ON, NULL)
// ioctl(fd, IOCTL_LCM_BACK_LIGHT_OFF, NULL)
// ioctl(fd, IOCTL_LCM_AUTO_SCROLL_ON, NULL);
// ioctl(fd, IOCTL_LCM_AUTO_SCROLL_OFF, NULL);
#define IOCTL_LCM_GOTO_XY               1       // jump to position x, y
#define IOCTL_LCM_CLS                   2       // clear all screen on LCM
#define IOCTL_LCM_CLEAN_LINE            3       // clear this line on position y
#define IOCTL_LCM_GET_XY                4       // get now position x, y
#define IOCTL_LCM_BACK_LIGHT_ON         5       // let back light on
#define IOCTL_LCM_BACK_LIGHT_OFF        6       // let back light off
#define IOCTL_LCM_AUTO_SCROLL_ON        13      // when the LCM full will auto scroll up one line
#define IOCTL_LCM_AUTO_SCROLL_OFF       14      // don't auto scroll

int	lcm_goto(lcm_xy_t *pos)
{
	int	fd;

	fd = open(LCM_DEVICE_NODE, O_RDONLY);
	if ( fd <=0 )
		return fd;
	ioctl(fd, IOCTL_LCM_GOTO_XY, pos);
	close(fd);
	return 0;
}

int	lcm_cls(void)
{
	int	fd, ret;

	fd = open(LCM_DEVICE_NODE, O_RDONLY);
	if ( fd <=0 )
		return fd;
	ioctl(fd, IOCTL_LCM_CLS, NULL);
	close(fd);
	return ret;
}

int	lcm_clear_line(void)
{
	int	fd;

	fd = open(LCM_DEVICE_NODE, O_RDONLY);
	if ( fd <=0 )
		return fd;
	ioctl(fd, IOCTL_LCM_CLEAN_LINE, NULL);
	close(fd);
	return 0;
}

int	lcm_get_pos(lcm_xy_t *pos)
{
	int	fd;

	fd = open(LCM_DEVICE_NODE, O_RDONLY);
	if ( fd <=0 )
		return fd;
	ioctl(fd, IOCTL_LCM_CLEAN_LINE, pos);
	close(fd);
	return 0;
}

int	lcm_back_light(int on_or_off)
{
	int	fd;

	if ( on_or_off != 1 && on_or_off != 0 )
		return -1;
	fd = open(LCM_DEVICE_NODE, O_RDONLY);
	if ( fd <=0 )
		return fd;
	if ( on_or_off )
		ioctl(fd, IOCTL_LCM_BACK_LIGHT_ON, NULL);
	else
		ioctl(fd, IOCTL_LCM_BACK_LIGHT_OFF, NULL);
	close(fd);
	return 0;
}
