
#include	<stdio.h>
#include        <stdlib.h>
#include        <fcntl.h>
#include        <errno.h>
#include        <termios.h>
#include        <time.h>
#include	<string.h>
#include        <sys/types.h>
#include        <sys/socket.h>
#include        <sys/ioctl.h>
#include        <linux/if.h>
#include	<netinet/tcp.h>
#include        <netinet/in.h>
#include        <arpa/inet.h>

#define BUF_LEN		1024

char	txbuf[BUF_LEN], rxbuf[BUF_LEN];

int main(int argc, char *argv[])
{
	int			netfd, i;
	int			tcpport;
	struct  sockaddr_in     des;
	fd_set			readfds, writefds;
        struct timeval		authtime;
	long			txcnt=0, rxcnt=0;
	long			t0, t1;

	if ( argc != 3 ) {
		printf("Usage: %s ip tcpport\n", argv[0]);
		return -1;
	}
	tcpport = atoi(argv[2]);
	for ( i=0; i<BUF_LEN; i++ )
		txbuf[i] = i & 0xff;
	netfd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if ( netfd < 0 ) {
		printf("Open socket fail !\n");
		return -1;
	}
	des.sin_addr.s_addr = inet_addr(argv[1]);
	des.sin_family = AF_INET;
	des.sin_port = htons(tcpport);
	i = sizeof(des);
	if ( connect(netfd, (struct sockaddr*)&des, i) < 0 ) {
		printf("Connect fail !\n");
		close(netfd);
		return -1;
	}
	printf("TCP port [%d] connection OK.\n", tcpport);
	t0 = t1 = time(0);
	while ( 1 ) {
		authtime.tv_usec = 0L;
		authtime.tv_sec = 1;
		FD_ZERO(&writefds);
		FD_ZERO(&readfds);
		FD_SET(netfd, &writefds);
		FD_SET(netfd, &readfds);
		if ( select(netfd+1, &readfds, &writefds, NULL, &authtime) >= 0 ) {
                        if (FD_ISSET (netfd, &writefds)) {
				i = write(netfd, txbuf, BUF_LEN);
				txcnt += i;
                        }
			if ( FD_ISSET(netfd, &readfds) ) {
				i = read(netfd, rxbuf, BUF_LEN);
				if ( i <= 0 ) {
					printf("Connection lost from read!\n");
					break;
				}
				rxcnt += i;
			}
                }
		t1 = time(0);
		if ( (t1 - t0) >= 10 ) {
			t0 = t1;
			printf("port [%d]: txcnt = %d, rxcnt = %d\n", tcpport, txcnt, rxcnt);
		}
	}
	close(netfd);
	printf("Stoping port %d\n", tcpport);
}
