
#include	<stdio.h>
#include        <stdlib.h>
#include        <fcntl.h>
#include        <errno.h>
#include        <termios.h>
#include        <time.h>
#include	<string.h>
#include        <sys/types.h>
#include        <sys/socket.h>
#include        <sys/ioctl.h>
#include        <linux/if.h>
#include	<netinet/tcp.h>
#include        <netinet/in.h>
#include        <arpa/inet.h>

#define BUF_LEN		1024
#define BUF_LEN_MASK	(BUF_LEN-1)

char	txbuf[BUF_LEN], rxbuf[BUF_LEN];

int main(int argc, char *argv[])
{
	int			netfd, i;
	int			udpport;
	int			deslen, fromlen;
	struct  sockaddr_in     des, from;
	fd_set			readfds, writefds;
        struct timeval		authtime;
	unsigned long		txcnt=0, rxcnt=0;
	long			t0, t1;

	if ( argc != 3 ) {
		printf("Usage: %s ipaddr udpport\n", argv[0]);
		return -1;
	}
	udpport = atoi(argv[2]);
	for ( i=0; i<BUF_LEN; i++ )
		txbuf[i] = i & 0xff;
	netfd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
	if ( netfd < 0 ) {
		printf("Open socket fail !\n");
		return -1;
	}
	from.sin_addr.s_addr = INADDR_ANY;
	from.sin_family = AF_INET;
	from.sin_port = htons(udpport);
	fromlen = sizeof(from);
	if ( bind(netfd, (struct sockaddr *)&from, fromlen) < 0 ) {
		printf("Bind networking fail !\n");
		return -1;
	}

	des.sin_addr.s_addr = inet_addr(argv[1]);
	des.sin_family = AF_INET;
	des.sin_port = htons(udpport);
	deslen = sizeof(des);
	printf("UDP port [%d] open OK.\n", udpport);
	t0 = t1 = time(0);
	while ( 1 ) {
		authtime.tv_usec = 0L;
		authtime.tv_sec = 1;
		FD_ZERO(&writefds);
		FD_ZERO(&readfds);
		if ( (txcnt - rxcnt) < BUF_LEN )
			FD_SET(netfd, &writefds);
		FD_SET(netfd, &readfds);
		if ( select(netfd+1, &readfds, &writefds, NULL, &authtime) >= 0 ) {
                        if ( FD_ISSET(netfd, &writefds) ) {
				i = sendto(netfd, txbuf, BUF_LEN, 0, (struct sockaddr *)&des, deslen);
				txcnt += i;
                        }
			if ( FD_ISSET(netfd, &readfds) ) {
				i = recvfrom(netfd, rxbuf, BUF_LEN, 0, (struct sockaddr *)&from, &fromlen);
				rxcnt += i;
			}
                }
		t1 = time(0);
		if ( (t1 - t0) >= 10 ) {
			t0 = t1;
			printf("port [%d]: txcnt = %d, rxcnt = %d\n", udpport, txcnt, rxcnt);
		}
	}
	close(netfd);
	printf("Stoping port %d\n", udpport);
}
